/* General libraries */
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <unistd.h>

/* UI Lib */
#include <gtk/gtk.h>

/* Internationalisation */
#include <libintl.h>
#define _(String) gettext (String)

#include "lyrc.h"
#include "lyrc_site.h"
#include "globals.h"
#include "filetype.h"

GtkWidget *editor, *field_layout;
GtkWidget *band, *disc, *wsong, *year, *text, *nick;
GtkWidget *msgfield, *msgbox, *upload_button;
GdkColormap *color_map;
GdkColor *black, *green;
GtkRcStyle *rc_style;
gchar *fifo = "";

void delete_lyrics_cache(  );

void get_lyrics( gchar * artist, gchar * song, gchar * real_artist, gchar * real_song,
				 gint force, gint script_nr )
{
	gchar *command, *file;
	FILE *f;
	
	command = g_strdup_printf( "touch \"%s%s - %s.lock\"", lyrics_dir, artist, song );
	system( command );
	g_free( command );
	command = g_strdup_printf( "\\rm \"%s%s - %s.lyrics.xml\" 2>/dev/null", lyrics_dir, artist, song );
	command = ( gchar * ) replace( command, "\\'", "'" );
	system( command );
	g_free( command );

	/* creates a file containing song info
	   to pass to the script */
	file = g_strdup_printf( "%s%s - %s.info", lyrics_dir, artist, song );
	file = ( gchar * ) replace( file, "\\'", "'" );
	f = fopen( file, "wb" );
	if( real_artist != NULL && real_song != NULL ) {
		fputs( "ARTIST\n", f );
		fputs( real_artist, f );
		fputc( '\n', f );
		fputs( "SONG\n", f );
		fputs( real_song, f );
		fputc( '\n', f );
	} else {
		fputs( "ARTIST\n", f );
		//fputs( cur_file_info->artist, f );
		fputs( artist, f );
		fputc( '\n', f );
		fputs( "SONG\n", f );
		//fputs( cur_file_info->title, f );
		fputs( song, f );
		fputc( '\n', f );
	}
	if( cur_file_info->album ) {
		fputs( "ALBUM\n", f );
		fputs( cur_file_info->album, f );
		fputc( '\n', f );
	}
	if( cur_file_info->year ) {
		fputs( "YEAR\n", f );
		fputs( cur_file_info->year, f );
		fputc( '\n', f );
	}
	if( force == 1 ) {
		fputs( "FORCE_RETRIEVE\n", f );
		fputs( "on\n", f );
	}
	fclose( f );

	/* Call the script */
	switch ( script_nr ) {
	 case 1:
		command = g_strdup_printf( "%s/coverviewer/lyrc_sing365.pl %s %s __00__ %s &",
								   DATADIR, lyrics_dir, artist, song );
		break;
	   
	 case 2:
		command = g_strdup_printf( "%s/coverviewer/lyrc_lyrc.pl %s %s __00__ %s &",
								   DATADIR, lyrics_dir, artist, song );
		break;
	   
	default:
		command = g_strdup_printf( "%s/coverviewer/lyrc_lyricsdownload.pl %s %s __00__ %s &",
								   DATADIR, lyrics_dir, artist, song );
		break;
	   
	}
	system( command );
	g_free( command );
}

void lyrics_websearch(  )
{
	gchar *cmd = g_strdup_printf( "%s &", lyrics_websearch_cmd );
	cmd = replace( cmd, "%a", play_artist );
	cmd = replace( cmd, "%t", play_song );
	//cmd=replace(cmd, " ", "%20");
	system( cmd );
	g_free( cmd );
}

/* Recheck the lyrics : delete the xml file */
void recheck(  )
{
	//delete_lyrics_cache(  );
	delete_lyrics(  );
	script_nr = 0;
}

void delete_lyrics(  )
{
	gchar *command;

	command = g_strdup_printf( "%s%s - %s.lyrics.xml", lyrics_dir, play_artist, play_song );
	command = ( gchar * ) replace( command, "\\'", "'" );
	printf( "[Lyrc] recheck lyrics (%s-%s)\n", play_artist, play_song );
	command = g_strdup_printf( "\\rm \"%s\" 2>/dev/null", command );
	system( command );
	g_free( command );
	command = g_strdup_printf( "\\rm \"%s%s - %s.lock\" 2>/dev/null", lyrics_dir, play_artist, play_song );
	system( command );
	g_free( command );
}

void delete_lyrics_cache(  )
{
	gchar *command;
	command = g_strdup_printf( "\\rm \"%ssing365.com/%s.links.html\" 2>/dev/null", lyrics_dir, play_artist );
	command = replace( command, "\\'", "'" );
	system( command );
	g_free( command );
}

/* upload lyrics functions */

	void stop_upload( GtkWidget * win )
{
	uploading_lyrics = FALSE;
	gtk_widget_destroy( win );
}

void upload_send( GtkWidget * upd )
{
	gchar *groupe, *disque, *titre, *annee, *texte, *pseudo, *cmd, *url, *tmp;
	GdkFont *font;

	/* create a fifo for communication with upload scripts */
	g_free( fifo );
	fifo = g_strdup_printf( "%s.advanced/%s", lyrics_dir, UP_MSG_FILE );
	if( mknod( fifo, S_IFIFO | 0600, 0 ) == -1 ) {
		printf( "mknod %s failed! You won't see anything when uploading...", fifo );
	}

	groupe = gtk_editable_get_chars( GTK_EDITABLE( band ), 0, -1 );
	disque = gtk_editable_get_chars( GTK_EDITABLE( disc ), 0, -1 );
	titre = gtk_editable_get_chars( GTK_EDITABLE( wsong ), 0, -1 );
	annee = gtk_editable_get_chars( GTK_EDITABLE( year ), 0, -1 );
	pseudo = gtk_editable_get_chars( GTK_EDITABLE( nick ), 0, -1 );
	texte = gtk_editable_get_chars( GTK_EDITABLE( text ), 0, -1 );

//  texte=replace(texte,"\n","%0D");    groupe=replace(groupe,"\n","%0D");
//  disque=replace(disque,"\n","%0D");  titre=replace(titre,"\n","%0D");
//  annee=replace(annee,"\n","%0D");    pseudo=replace(pseudo,"\n","%0D");

	url = g_strdup_printf( "http://www.lyrc.com.ar/en/add/add.php?grupo=%s&tema=%s", groupe, titre );
	url = g_strdup_printf( "%s&disco=%s", url, disque );
	url = g_strdup_printf( "%s&ano=%s", url, annee );
	url = g_strdup_printf( "%s&nick=%s", url, pseudo );
	url = g_strdup_printf( "%s&texto=%s", url, texte );
	url = g_strdup_printf( "%s&procesado=1", url );
	url = replace( url, "\n", "%0D" );
	url = replace( url, "\"", "%22" );

/*	artist=(gchar *) strdup(cur_file_info->artist);
	song=(gchar *) strdup(cur_file_info->title);
	artist=(gchar *) net_purge(artist);
	song=(gchar *) net_purge(song);
	file=g_strdup_printf("%s%s - %s.upload",lyrics_dir,artist,song);
	file=(gchar *) replace(file,"\\'","'");
	
	f=fopen(file,"wb");
		fputs(groupe,f); fputc('\n',f);
		fputs(disque,f); fputc('\n',f);
		fputs(titre,f); fputc('\n',f);
		fputs(annee,f); fputc('\n',f);
		fputs(texte,f); fputc('\n',f);
		fputs(pseudo,f);
	fclose(f);
	
	g_free(file);
	file=g_strdup_printf("%s/coverviewer/submit.py %s %s ____ %s &",DATADIR,lyrics_dir,artist,song);
	system(file);*/

	cmd = g_strdup_printf( "%s/coverviewer/lyrc_upload.pl %s.advanced %s \"%s\" &",
						   DATADIR, lyrics_dir, UP_MSG_FILE, url );
	system( cmd );

	gtk_widget_set_sensitive( upload_button, FALSE );

	font = gdk_font_load( lyrics_fontname );
	if( !font ) font = gdk_font_load( "fixed" );
	if( ( tmp = gtk_editable_get_chars( GTK_EDITABLE( msgfield ), 0, -1 ) ) )
		gtk_editable_delete_text( GTK_EDITABLE( msgfield ), 0, -1 );
	gtk_text_insert( GTK_TEXT( msgfield ), font, green, black, "Uploading .", -1 );
	gtk_widget_show( msgbox );

	gdk_font_unref( font );
	g_free( cmd );
	g_free( url );
	g_free( groupe );
	g_free( disque );
	g_free( titre );
	g_free( annee );
	g_free( texte );
	g_free( pseudo );
	//stop_upload(upd);
}

void show_upload_msg(  )
{
	int file, num;
	gchar *tmp;
	GdkFont *font;

	if( ( file = open( fifo, O_RDONLY | O_NDELAY ) ) == -1 )
		return;

	font = gdk_font_load( lyrics_fontname );
	if( !font ) font = gdk_font_load( "fixed" );

	gchar *buffer = g_new( char, 64000 );
	num = read( file, buffer, 64000 );
	if( num > 0 ) {
		buffer[num] = '\0';
	} else {
		g_free( buffer );
		if( num == 0 )
			close( file );
		gtk_text_insert( GTK_TEXT( msgfield ), font, green, black, ".", -1 );
		gdk_font_unref( font );
		return;
	}

	if( ( tmp = gtk_editable_get_chars( GTK_EDITABLE( msgfield ), 0, -1 ) ) )
		gtk_editable_delete_text( GTK_EDITABLE( msgfield ), 0, -1 );
	gtk_text_insert( GTK_TEXT( msgfield ), font, green, black, buffer, -1 );
	gtk_widget_set_sensitive( upload_button, TRUE );

	g_free( buffer );
	g_free( tmp );
	close( file );
	unlink( fifo );
	gdk_font_unref( font );
}

void save_lyrics( GtkWidget * upd )
{
	gchar *texte;
	gchar *artist, *song;
	gchar *file;
	FILE *f;

	artist = gtk_editable_get_chars( GTK_EDITABLE( band ), 0, -1 );
	song = gtk_editable_get_chars( GTK_EDITABLE( wsong ), 0, -1 );
	texte = gtk_editable_get_chars( GTK_EDITABLE( text ), 0, -1 );

	artist = net_purge( artist );
	song = net_purge( song );
	file = g_strdup_printf( "%s%s - %s.lyrics.xml", lyrics_dir, artist, song );
	file = ( gchar * ) replace( file, "\\'", "'" );
	g_strdown( file );

	artist = utf8_encode( artist );
	song = utf8_encode( song );
	texte = utf8_encode( texte );

	if( strlen( texte ) > 0 ) {
		f = fopen( file, "wb" );
		fprintf( f, "<?xml version=\"1.0\" encoding=\"utf-8\" ?>\n"
				 "<lyrc><result>\n"
				 "<name>%s</name>\n"
				 "<group>%s</group>\n" "<lyric>%s\n</lyric>\n" "</result></lyrc>\n", song, artist, texte );
		fclose( f );
	}
	free( artist );
	free( song );
	free( texte );
	g_free( file );
	stop_upload( upd );
}

void edit_lyrics(  )
{
	GtkWidget *box, *label, *scrollwin, *menu, *item;
	gchar *cmd = NULL;
	gchar *url = NULL;
	gchar *source = NULL;
	FILE *f;
	GtkTooltips *tip = gtk_tooltips_new(  );
	gint winwidth = 500;
	gint winheight = 500;

	if( uploading_lyrics ) {
		stop_upload( editor );
		return;
	}

	uploading_lyrics = TRUE;
	editor = gtk_dialog_new(  );
	gtk_window_set_title( ( GtkWindow * ) editor, _( "Edit and upload lyrics" ) );

	/*band  <input name="grupo" value="dionysos"> */
	box = gtk_hbox_new( FALSE, 0 );
	label = gtk_label_new( _( "Artist/Band" ) );
	gtk_box_pack_start( GTK_BOX( box ), label, FALSE, FALSE, 10 );
	band = gtk_entry_new(  );
	gtk_entry_set_text( GTK_ENTRY( band ), cur_file_info->artist );
	gtk_box_pack_start( GTK_BOX( box ), band, TRUE, TRUE, 10 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->vbox ), box, FALSE, FALSE, 5 );

	/*disc <input name="disco" value=""> */
	box = gtk_hbox_new( FALSE, 0 );
	label = gtk_label_new( _( "Album" ) );
	gtk_box_pack_start( GTK_BOX( box ), label, FALSE, FALSE, 10 );
	disc = gtk_entry_new(  );
	if( cur_file_info->album )
		gtk_entry_set_text( GTK_ENTRY( disc ), cur_file_info->album );
	gtk_box_pack_start( GTK_BOX( box ), disc, TRUE, TRUE, 10 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->vbox ), box, FALSE, FALSE, 5 );

	/*song <input name="tema" value="coiffeur doiseaux"> */
	box = gtk_hbox_new( FALSE, 0 );
	label = gtk_label_new( _( "Song" ) );
	gtk_box_pack_start( GTK_BOX( box ), label, FALSE, FALSE, 10 );
	wsong = gtk_entry_new(  );
	gtk_entry_set_text( GTK_ENTRY( wsong ), cur_file_info->title );
	gtk_box_pack_start( GTK_BOX( box ), wsong, TRUE, TRUE, 10 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->vbox ), box, FALSE, FALSE, 5 );

	/*year <input name="ano" value=""> */
	box = gtk_hbox_new( FALSE, 0 );
	label = gtk_label_new( _( "Year" ) );
	gtk_box_pack_start( GTK_BOX( box ), label, FALSE, FALSE, 10 );
	year = gtk_entry_new(  );
	if( cur_file_info->year )
		gtk_entry_set_text( GTK_ENTRY( year ), cur_file_info->year );
	gtk_box_pack_start( GTK_BOX( box ), year, TRUE, TRUE, 10 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->vbox ), box, FALSE, FALSE, 5 );

	/*text <textarea rows=10 cols=20 name="texto"></textarea> */
	box = gtk_hbox_new( FALSE, 0 );
	label = gtk_label_new( _( "Lyrics" ) );
	gtk_box_pack_start( GTK_BOX( box ), label, FALSE, FALSE, 10 );
	scrollwin = gtk_scrolled_window_new( NULL, NULL );
	gtk_scrolled_window_set_policy( GTK_SCROLLED_WINDOW( scrollwin ), GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC );
	text = gtk_text_new( NULL, NULL );
	gtk_text_set_editable( GTK_TEXT( text ), TRUE );
	if( lyrics[0] != '\t' ) {
		gint pos = 0;
		gtk_editable_insert_text( GTK_EDITABLE( text ), lyrics_nobr, strlen( lyrics_nobr ), &pos );
	}
	gtk_container_add( GTK_CONTAINER( scrollwin ), text );
	gtk_box_pack_start( GTK_BOX( box ), scrollwin, TRUE, TRUE, 10 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->vbox ), box, TRUE, TRUE, 5 );

	/*Nick <input name="nick" value="" */
	box = gtk_hbox_new( FALSE, 0 );
	label = gtk_label_new( _( "Nick/Email" ) );
	gtk_box_pack_start( GTK_BOX( box ), label, FALSE, FALSE, 10 );
	nick = gtk_entry_new(  );
	gtk_entry_set_text( GTK_ENTRY( nick ), g_get_user_name(  ) );
	gtk_box_pack_start( GTK_BOX( box ), nick, TRUE, TRUE, 10 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->vbox ), box, FALSE, FALSE, 5 );

	/*  <input type="submit" value="A G R E G A R" name=submit1>
	   <input type="hidden" name="procesado" value="1"> */


	/* message field */
	field_layout = gtk_fixed_new(  );

	color_map = gdk_colormap_get_system(  );
	black = ( GdkColor * ) g_malloc( sizeof( GdkColor ) );
	black->red = back_red;
	black->green = back_green;
	black->blue = back_blue;
	green = ( GdkColor * ) g_malloc( sizeof( GdkColor ) );
	green->red = front_red;
	green->green = front_green;
	green->blue = front_blue;

	gdk_colormap_alloc_color( color_map, green, FALSE, TRUE );
	gdk_colormap_alloc_color( color_map, black, FALSE, TRUE );
	rc_style = gtk_rc_style_new(  );
	rc_style->text[GTK_STATE_NORMAL] = *green;
	rc_style->base[GTK_STATE_NORMAL] = *black;
	rc_style->bg[GTK_STATE_NORMAL] = *black;
	rc_style->fg[GTK_STATE_NORMAL] = *black;
	rc_style->color_flags[GTK_STATE_NORMAL] |= GTK_RC_TEXT | GTK_RC_BASE | GTK_RC_FG | GTK_RC_BG;

	msgbox = gtk_hbox_new( FALSE, 0 );
	//scrollwin=gtk_scrolled_window_new(NULL, NULL);
	//gtk_scrolled_window_set_policy(GTK_SCROLLED_WINDOW(scrollwin),
	//                             GTK_POLICY_AUTOMATIC, GTK_POLICY_AUTOMATIC);
	msgfield = gtk_text_new( NULL, NULL );
	gtk_widget_set_usize( msgfield, winwidth - 5, 30 );
	gtk_text_set_word_wrap( GTK_TEXT( msgfield ), TRUE );
	//gtk_scrolled_window_add_with_viewport(GTK_SCROLLED_WINDOW(scrollwin), field_layout);
	gtk_fixed_put( GTK_FIXED( field_layout ), msgfield, 1, 1 );
	//gtk_box_pack_start(GTK_BOX(msgbox),scrollwin,TRUE,TRUE,1);
	gtk_box_pack_start( GTK_BOX( msgbox ), field_layout, TRUE, TRUE, 1 );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->vbox ), msgbox, FALSE, FALSE, 5 );
	gtk_widget_modify_style( field_layout, rc_style );
	gtk_widget_modify_style( msgfield, rc_style );

	/* emtpy label... For the look */
	gtk_box_set_homogeneous( GTK_BOX( GTK_DIALOG( editor )->action_area ), FALSE );
	label = gtk_label_new( "" );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->action_area ), label, TRUE, TRUE, FALSE );


	/* the "Search in google" browser list --------------------------------->> */
	url = g_strdup_printf( "http://www.google.com/search?q=%s %s %s", play_artist, play_song,
						   "lyrics OR text" );
	url = replace( url, " ", "%20" );
	menu = gtk_menu_new(  );
	f = fopen( g_strdup_printf( "%s.advanced/browsers.txt", lyrics_dir ), "rb" );
	// find the browsers
	source = ( gchar * ) malloc( 1000 );
	fgets( source, 1000, f );
	while( feof( f ) == 0 ) {
		source[strlen( source ) - 1] = 0;
		if( strstr( source, "kfmclient" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (KDE Def.)" ) );
			cmd = g_strdup_printf( "%s exec \"%s\"&", source, url );
		} else if( strstr( source, "MozillaFirebird" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (FireBird)" ) );
			cmd = g_strdup_printf( "ps x |grep -q '%s' && %s -remote \"openURL(%s, new-window)\" || %s \"%s\"&",
								   source, source, url, source, url );
		} else if( strstr( source, "mozilla-firefox" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (Firefox)" ) );
			cmd = g_strdup_printf( "ps x |grep -q '%s' && %s -remote \"openURL(%s, new-window)\" || %s \"%s\"&",
								   source, source, url, source, url );
		} else if( strstr( source, "mozilla" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (Mozilla)" ) );
			cmd = g_strdup_printf( "ps x |grep -q '%s' && %s -remote \"openURL(%s, new-window)\" || %s \"%s\"&",
								   source, source, url, source, url );
		} else if( strstr( source, "netscape" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (Netscape)" ) );
			cmd = g_strdup_printf( "ps x |grep -q '%s' && %s -remote \"openURL(%s, new-window)\" || %s \"%s\"&",
								   source, source, url, source, url );
		} else if( strstr( source, "lynx" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (Lynx)" ) );
			cmd = g_strdup_printf( "xterm -e %s \"%s\"&", source, url );
		} else if( strstr( source, "opera" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (Opera)" ) );
			cmd = strdup( url );
			cmd = replace( cmd, " ", "%20" );
			cmd = g_strdup_printf( "%s -newwindow \"%s\"&", source, cmd );
		} else if( strstr( source, "epiphany" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (Epiphany)" ) );
			cmd = g_strdup_printf( "%s \"%s\"&", source, url );
		} else if( strstr( source, "galeon" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (Galeon)" ) );
			cmd = g_strdup_printf( "%s \"%s\"&", source, url );
		} else if( strstr( source, "konqueror" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (Konqueror)" ) );
			cmd = g_strdup_printf( "%s \"%s\"&", source, url );
		} else if( strstr( source, "w3m" ) ) {
			item = gtk_menu_item_new_with_label( _( "Web search (w3m)" ) );
			cmd = g_strdup_printf( "%s \"%s\"&", source, url );
		} else {
			item = gtk_menu_item_new_with_label( _( " --- " ) );
			cmd = "&";
		}

		gtk_signal_connect_object( GTK_OBJECT( item ), "activate", GTK_SIGNAL_FUNC( system ), ( gpointer ) cmd );
		gtk_widget_show( item );
		gtk_menu_append( GTK_MENU( menu ), item );
		fgets( source, 1000, f );
	}
	free( source );
	fclose( f );
	item = gtk_option_menu_new(  );
	gtk_option_menu_set_menu( GTK_OPTION_MENU( item ), menu );
	gtk_option_menu_set_history( GTK_OPTION_MENU( item ), 0 );
	gtk_widget_show( item );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->action_area ), item, FALSE, TRUE, FALSE );
	/* << ------------------------------------------------------------------ */

	/* the recheck button */
	label = gtk_button_new_with_label( _( "Recheck" ) );
	gtk_signal_connect_object( GTK_OBJECT( label ), "clicked", GTK_SIGNAL_FUNC( recheck ), NULL );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->action_area ), label, FALSE, TRUE, FALSE );
	gtk_tooltips_set_tip( GTK_TOOLTIPS( tip ), label, _( "(Delete lyrics and) Redo auto-search" ), NULL );

	/* the submit button */
//  label = gtk_button_new_with_label(_("Save & Upload"));
//  gtk_box_pack_start(GTK_BOX(GTK_DIALOG(editor)->action_area),label,FALSE,TRUE,FALSE);
//  gtk_signal_connect_object (GTK_OBJECT (label), "clicked",   GTK_SIGNAL_FUNC (upload_send),(GtkObject *) editor);
//  gtk_tooltips_set_tip(GTK_TOOLTIPS(tip),label,_("Save locally and try upload to sing365.com"),NULL);
// 
//  gtk_widget_set_sensitive(label, FALSE);

	/* the "upload to lyrc" button ----------------------------------->> */
	upload_button = gtk_button_new_with_label( _( "Upload" ) );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->action_area ), upload_button, FALSE, TRUE, FALSE );
	gtk_signal_connect_object( GTK_OBJECT( upload_button ), "clicked", GTK_SIGNAL_FUNC( upload_send ),
							   ( GtkObject * ) editor );
	gtk_tooltips_set_tip( GTK_TOOLTIPS( tip ), upload_button, _( "Try upload to lyrc.com.ar database" ), NULL );

	/* the save button */
	label = gtk_button_new_with_label( _( " OK " ) );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->action_area ), label, FALSE, TRUE, FALSE );
	gtk_signal_connect_object( GTK_OBJECT( label ), "clicked", GTK_SIGNAL_FUNC( save_lyrics ), ( GtkObject * ) editor );
	gtk_tooltips_set_tip( GTK_TOOLTIPS( tip ), label, _( "Save lyrics and close" ), NULL );
	
	/* the cancel button */
	label = gtk_button_new_with_label( _( "Cancel" ) );
	gtk_box_pack_start( GTK_BOX( GTK_DIALOG( editor )->action_area ), label, FALSE, TRUE, FALSE );
	gtk_signal_connect_object( GTK_OBJECT( label ), "clicked", GTK_SIGNAL_FUNC( stop_upload ), ( GtkObject * ) editor );
	gtk_tooltips_set_tip( GTK_TOOLTIPS( tip ), label, _( "Don't save lyrics and close" ), NULL );
	
	gtk_signal_connect( GTK_OBJECT( editor ), "destroy", GTK_SIGNAL_FUNC( stop_upload ), editor );

	/* Let the show begin */
	gtk_window_set_policy( GTK_WINDOW( editor ), FALSE, TRUE, FALSE );
	gtk_widget_show_all( editor );
	gtk_widget_hide( msgbox );

	gdk_window_move_resize( editor->window, gdk_screen_width(  ) / 2 - 350, gdk_screen_height(  ) / 2 - 300,
							winwidth, winheight );
}
